t / test-lib.shon commit git-svn: add tests for command-line usage of init and clone commands (41337e2)
   1#!/bin/sh
   2#
   3# Copyright (c) 2005 Junio C Hamano
   4#
   5
   6# For repeatability, reset the environment to known value.
   7LANG=C
   8LC_ALL=C
   9PAGER=cat
  10TZ=UTC
  11export LANG LC_ALL PAGER TZ
  12EDITOR=:
  13VISUAL=:
  14unset GIT_EDITOR
  15unset AUTHOR_DATE
  16unset AUTHOR_EMAIL
  17unset AUTHOR_NAME
  18unset COMMIT_AUTHOR_EMAIL
  19unset COMMIT_AUTHOR_NAME
  20unset EMAIL
  21unset GIT_ALTERNATE_OBJECT_DIRECTORIES
  22unset GIT_AUTHOR_DATE
  23GIT_AUTHOR_EMAIL=author@example.com
  24GIT_AUTHOR_NAME='A U Thor'
  25unset GIT_COMMITTER_DATE
  26GIT_COMMITTER_EMAIL=committer@example.com
  27GIT_COMMITTER_NAME='C O Mitter'
  28unset GIT_DIFF_OPTS
  29unset GIT_DIR
  30unset GIT_WORK_TREE
  31unset GIT_EXTERNAL_DIFF
  32unset GIT_INDEX_FILE
  33unset GIT_OBJECT_DIRECTORY
  34unset SHA1_FILE_DIRECTORIES
  35unset SHA1_FILE_DIRECTORY
  36GIT_MERGE_VERBOSITY=5
  37export GIT_MERGE_VERBOSITY
  38export GIT_AUTHOR_EMAIL GIT_AUTHOR_NAME
  39export GIT_COMMITTER_EMAIL GIT_COMMITTER_NAME
  40export EDITOR VISUAL
  41
  42# Protect ourselves from common misconfiguration to export
  43# CDPATH into the environment
  44unset CDPATH
  45
  46case $(echo $GIT_TRACE |tr "[A-Z]" "[a-z]") in
  47        1|2|true)
  48                echo "* warning: Some tests will not work if GIT_TRACE" \
  49                        "is set as to trace on STDERR ! *"
  50                echo "* warning: Please set GIT_TRACE to something" \
  51                        "other than 1, 2 or true ! *"
  52                ;;
  53esac
  54
  55# Each test should start with something like this, after copyright notices:
  56#
  57# test_description='Description of this test...
  58# This test checks if command xyzzy does the right thing...
  59# '
  60# . ./test-lib.sh
  61
  62[ "x$TERM" != "xdumb" ] &&
  63        [ -t 1 ] &&
  64        tput bold >/dev/null 2>&1 &&
  65        tput setaf 1 >/dev/null 2>&1 &&
  66        tput sgr0 >/dev/null 2>&1 &&
  67        color=t
  68
  69while test "$#" -ne 0
  70do
  71        case "$1" in
  72        -d|--d|--de|--deb|--debu|--debug)
  73                debug=t; shift ;;
  74        -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
  75                immediate=t; shift ;;
  76        -h|--h|--he|--hel|--help)
  77                help=t; shift ;;
  78        -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
  79                verbose=t; shift ;;
  80        -q|--q|--qu|--qui|--quie|--quiet)
  81                quiet=t; shift ;;
  82        --no-color)
  83            color=; shift ;;
  84        --no-python)
  85                # noop now...
  86                shift ;;
  87        *)
  88                break ;;
  89        esac
  90done
  91
  92if test -n "$color"; then
  93        say_color () {
  94                case "$1" in
  95                        error) tput bold; tput setaf 1;; # bold red
  96                        skip)  tput bold; tput setaf 2;; # bold green
  97                        pass)  tput setaf 2;;            # green
  98                        info)  tput setaf 3;;            # brown
  99                        *) test -n "$quiet" && return;;
 100                esac
 101                shift
 102                echo "* $*"
 103                tput sgr0
 104        }
 105else
 106        say_color() {
 107                test -z "$1" && test -n "$quiet" && return
 108                shift
 109                echo "* $*"
 110        }
 111fi
 112
 113error () {
 114        say_color error "error: $*"
 115        trap - exit
 116        exit 1
 117}
 118
 119say () {
 120        say_color info "$*"
 121}
 122
 123test "${test_description}" != "" ||
 124error "Test script did not set test_description."
 125
 126if test "$help" = "t"
 127then
 128        echo "$test_description"
 129        exit 0
 130fi
 131
 132exec 5>&1
 133if test "$verbose" = "t"
 134then
 135        exec 4>&2 3>&1
 136else
 137        exec 4>/dev/null 3>/dev/null
 138fi
 139
 140test_failure=0
 141test_count=0
 142
 143trap 'echo >&5 "FATAL: Unexpected exit with code $?"; exit 1' exit
 144
 145test_tick () {
 146        if test -z "${test_tick+set}"
 147        then
 148                test_tick=1112911993
 149        else
 150                test_tick=$(($test_tick + 60))
 151        fi
 152        GIT_COMMITTER_DATE="$test_tick -0700"
 153        GIT_AUTHOR_DATE="$test_tick -0700"
 154        export GIT_COMMITTER_DATE GIT_AUTHOR_DATE
 155}
 156
 157# You are not expected to call test_ok_ and test_failure_ directly, use
 158# the text_expect_* functions instead.
 159
 160test_ok_ () {
 161        test_count=$(expr "$test_count" + 1)
 162        say_color "" "  ok $test_count: $@"
 163}
 164
 165test_failure_ () {
 166        test_count=$(expr "$test_count" + 1)
 167        test_failure=$(expr "$test_failure" + 1);
 168        say_color error "FAIL $test_count: $1"
 169        shift
 170        echo "$@" | sed -e 's/^/        /'
 171        test "$immediate" = "" || { trap - exit; exit 1; }
 172}
 173
 174
 175test_debug () {
 176        test "$debug" = "" || eval "$1"
 177}
 178
 179test_run_ () {
 180        eval >&3 2>&4 "$1"
 181        eval_ret="$?"
 182        return 0
 183}
 184
 185test_skip () {
 186        this_test=$(expr "./$0" : '.*/\(t[0-9]*\)-[^/]*$')
 187        this_test="$this_test.$(expr "$test_count" + 1)"
 188        to_skip=
 189        for skp in $GIT_SKIP_TESTS
 190        do
 191                case "$this_test" in
 192                $skp)
 193                        to_skip=t
 194                esac
 195        done
 196        case "$to_skip" in
 197        t)
 198                say_color skip >&3 "skipping test: $@"
 199                test_count=$(expr "$test_count" + 1)
 200                say_color skip "skip $test_count: $1"
 201                : true
 202                ;;
 203        *)
 204                false
 205                ;;
 206        esac
 207}
 208
 209test_expect_failure () {
 210        test "$#" = 2 ||
 211        error "bug in the test script: not 2 parameters to test-expect-failure"
 212        if ! test_skip "$@"
 213        then
 214                say >&3 "expecting failure: $2"
 215                test_run_ "$2"
 216                if [ "$?" = 0 -a "$eval_ret" != 0 -a "$eval_ret" -lt 129 ]
 217                then
 218                        test_ok_ "$1"
 219                else
 220                        test_failure_ "$@"
 221                fi
 222        fi
 223        echo >&3 ""
 224}
 225
 226test_expect_success () {
 227        test "$#" = 2 ||
 228        error "bug in the test script: not 2 parameters to test-expect-success"
 229        if ! test_skip "$@"
 230        then
 231                say >&3 "expecting success: $2"
 232                test_run_ "$2"
 233                if [ "$?" = 0 -a "$eval_ret" = 0 ]
 234                then
 235                        test_ok_ "$1"
 236                else
 237                        test_failure_ "$@"
 238                fi
 239        fi
 240        echo >&3 ""
 241}
 242
 243test_expect_code () {
 244        test "$#" = 3 ||
 245        error "bug in the test script: not 3 parameters to test-expect-code"
 246        if ! test_skip "$@"
 247        then
 248                say >&3 "expecting exit code $1: $3"
 249                test_run_ "$3"
 250                if [ "$?" = 0 -a "$eval_ret" = "$1" ]
 251                then
 252                        test_ok_ "$2"
 253                else
 254                        test_failure_ "$@"
 255                fi
 256        fi
 257        echo >&3 ""
 258}
 259
 260# Most tests can use the created repository, but some amy need to create more.
 261# Usage: test_create_repo <directory>
 262test_create_repo () {
 263        test "$#" = 1 ||
 264        error "bug in the test script: not 1 parameter to test-create-repo"
 265        owd=`pwd`
 266        repo="$1"
 267        mkdir "$repo"
 268        cd "$repo" || error "Cannot setup test environment"
 269        "$GIT_EXEC_PATH/git" init --template=$GIT_EXEC_PATH/templates/blt/ >/dev/null 2>&1 ||
 270        error "cannot run git init -- have you built things yet?"
 271        mv .git/hooks .git/hooks-disabled
 272        cd "$owd"
 273}
 274
 275test_done () {
 276        trap - exit
 277        case "$test_failure" in
 278        0)
 279                # We could:
 280                # cd .. && rm -fr trash
 281                # but that means we forbid any tests that use their own
 282                # subdirectory from calling test_done without coming back
 283                # to where they started from.
 284                # The Makefile provided will clean this test area so
 285                # we will leave things as they are.
 286
 287                say_color pass "passed all $test_count test(s)"
 288                exit 0 ;;
 289
 290        *)
 291                say_color error "failed $test_failure among $test_count test(s)"
 292                exit 1 ;;
 293
 294        esac
 295}
 296
 297# Test the binaries we have just built.  The tests are kept in
 298# t/ subdirectory and are run in trash subdirectory.
 299PATH=$(pwd)/..:$PATH
 300GIT_EXEC_PATH=$(pwd)/..
 301GIT_TEMPLATE_DIR=$(pwd)/../templates/blt
 302GIT_CONFIG=.git/config
 303export PATH GIT_EXEC_PATH GIT_TEMPLATE_DIR GIT_CONFIG
 304
 305GITPERLLIB=$(pwd)/../perl/blib/lib:$(pwd)/../perl/blib/arch/auto/Git
 306export GITPERLLIB
 307test -d ../templates/blt || {
 308        error "You haven't built things yet, have you?"
 309}
 310
 311if ! test -x ../test-chmtime; then
 312        echo >&2 'You need to build test-chmtime:'
 313        echo >&2 'Run "make test-chmtime" in the source (toplevel) directory'
 314        exit 1
 315fi
 316
 317# Test repository
 318test=trash
 319rm -fr "$test"
 320test_create_repo $test
 321cd "$test"
 322
 323this_test=$(expr "./$0" : '.*/\(t[0-9]*\)-[^/]*$')
 324for skp in $GIT_SKIP_TESTS
 325do
 326        to_skip=
 327        for skp in $GIT_SKIP_TESTS
 328        do
 329                case "$this_test" in
 330                $skp)
 331                        to_skip=t
 332                esac
 333        done
 334        case "$to_skip" in
 335        t)
 336                say_color skip >&3 "skipping test $this_test altogether"
 337                say_color skip "skip all tests in $this_test"
 338                test_done
 339        esac
 340done